unit ThumbNail;
interface
{Thumbimage, Thumbnail components
  Thumbimage is a Timage descentant wich passes the control of the mouse events
  to the thumbnail and have the ability to change an images look buy changing
  the rgb values with the changergb,changergbcurve procedures.
  You can have precise control over the images look.
  The changergb procedure just adds the values you pass to its rgb variables to
  the actual values of the image.
  The Changergbcurves procedure just replaces the value of the rgb values
  accordingly with the values that passed in the the arrays.
  e.g.
  the r array in the position 15 has a value of 35 this meens that wherever in
  the picture there is a pixels which has a red value equall to 15 it will be ]
  replaced with the value 35.

  Thumbnail is what the name says a component to simply shrink an image
  proportionaly to fit in a portion of the screen with some extra mouse handling
  to create a button like effect.Just give it a filename and it will do the work
  for you.
}

uses
  Classes, Controls, ExtCtrls, jpeg, sysutils, messages, dialogs, graphics,
  windows, forms, misc, Gifimage;
  {$R ThumbNail.res}
Const
  TH_ImageSizeChanged = WM_user +1;
type
  Tangle      = (AT0, AT90,AT180,AT270);
  TRGB        = array[0..20000] of TRGBTriple;
  PRGB        = ^TRGB;
  TcurveArray = Array[0..255] of byte;

TTitleNotify = procedure (Sender: TObject; FileName: string; var ThumbNailTitle: string) of object;
TDestroynotify = procedure (sender: Tobject; modified:boolean;var break:boolean) of object;
TRotateNotify = procedure (sender:Tobject;percent:byte;var break:boolean) of object;

Pthumbshape = ^TThumbshape;
Tthumbshape = class(Tshape)
  Private
  { Private declarations }
    procedure mousedown(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);override;
    procedure mousemove(Shift: TShiftState; X,Y: Integer);override;
    procedure mouseup(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);override;
    procedure click;override;
    procedure DblClick;override;
  protected
  { Protected declarations }
  public
  { Public declarations }
  published
  { Published declarations }
end;

PThumbtitle=^Tthumbtitle;
TThumbTitle = class(Tpanel)
  private
    procedure Click;override;
    procedure DblClick;override;
    procedure MouseDown(button:Tmousebutton;shift:Tshiftstate;x,y:integer);override;
    procedure MouseUp(button:Tmousebutton;shift:tshiftstate;x,y:integer);override;
    procedure MouseMove(Shift:TShiftState;x,y:integer);override;
  protected
  public
  published
end;{}

Pthumbimage=^TThumbImage;
TThumbImage = class(Timage)
  Private
    { Private declarations }
    Cangle       : TAngle;
    PChanged     : Boolean;
    Tbrake       : Boolean;
    EVonrelease  : Tdestroynotify;
    EvOnprocess  : Tprogressnotify;
    P_onrotate   : Trotatenotify;
    procedure MouseDown(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);override;
    procedure MouseMove(Shift: TShiftState; X,Y: Integer);override;
    procedure MouseUp(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);override;
    procedure Click; override;
    procedure DblClick;override;
    constructor Create(AOwner:Tcomponent);override;
    Destructor Destroy;override;
//    procedure free;override;
    procedure Rotate90;
    procedure Rotate180;
    procedure Rotate270;
    procedure Rotate(Vangle:Tangle);
    function GetModify:boolean;
  protected
    { Protected declarations }
  public
    { Public declarations }
    Procedure ChangeRGB(r,g,b:longint);
    Procedure ChangeRGBCurves(R,G,B:TCurvearray);
    Procedure ScaleDown(MaxW,MaxH:longint);
  published
   { Published declarations }
   property Angle     : Tangle  read Cangle write Rotate;
   Property Modified  : boolean read PChanged;
   Property OnRelease : TdestroyNotify read EVonrelease write Evonrelease;
   Property CanModify : Boolean read getmodify;
   property OnRotate  : Trotatenotify read P_OnRotate write P_OnRotate;

end;

PThumbNail = ^TThumbNail;
TThumbNail = class(TPanel)
  private
  { Private declarations }
  V_Title           : string;
  V_TitlePanel      : TTHumbtitle;
  V_TitlePanelColor : TColor;
  V_TitlePanelFont  : TFont;
  V_Shape           : TThumbShape;
  FDFilecreated     : string;
  FDFilechanged     : string;
  FDFileAccessed    : string;
  FDFileSize        : longint;
  Pstream           : TStream;
  IGWidth           : longint;
  IGHeight          : longint;
  THClientHeight    : word;
  THClientWidth     : word;
   {Other}
  V_Updated         : boolean;
  V_ImageReady      : boolean;
  Fphoto            : string;
	{Event Related}
  V_OnGetTitle      : TTitleNotify;
  MousePressed      : Boolean;
  Destroying        : Boolean;
  PAsButton         : Boolean;
  Tminimize         : Boolean;
	{Event Related}
    Procedure MouseDown(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);override;
    Procedure MouseMove(Shift: TShiftState; X,Y: Integer);override;
    Procedure MouseUp(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);override;
    Procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    Procedure PhotoOnProgress(Sender: TObject; Stage: TProgressStage; PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string);
    Procedure RefreshFont(Sender: TObject);
	{Normal Procedures}
    Procedure SetFile(Afile:string);
    Procedure resize;override;
    Procedure Calculateimagesize;virtual;
    Procedure setClientWidth(Awidth:word);
    Procedure setdummystr(AnStr:string);
    Procedure Setminimize(Min:boolean);
    Procedure setdummyint(AnInt:longint);
    Procedure SetClientHeight(aheight:word);
	{Property Procedures}
    Procedure PSetV_Title(const Value: string);
    Procedure PSetV_TitlePanelColor(const Value: TColor);
    Procedure Setstream(AStream:Tstream);
    Procedure PSetV_TitlePanelFont(const Value: TFont);
    Procedure getfileinfo;
    Protected
	{ Protected declarations }
    procedure THSizechanged(var Message:tmessage); message TH_ImagesizeChanged;
  public
	{ Public declarations }
  Photo:TThumbImage;
  Constructor Create(Aowner:Tcomponent);override;
  Destructor Destroy; override;
  procedure SetTitlePanel(P_Title: String; P_Font: TFont; P_Color: TColor);
  Property Stream        : Tstream read Pstream write setstream;
  published
	{ Published declarations }
     property Filename:string read Fphoto write SetFile;
     property Title: string read V_Title write PSetV_Title;
     property TitleColor: TColor read V_TitlePanelColor write PSetV_TitlePanelColor;
     property TitleFont: TFont read V_TitlePanelFont write PSetV_TitlePanelFont;
     property ImageReady: boolean read V_ImageReady;
	{Event Related}
     property OnGetTitle: TTitleNotify read V_OnGetTitle write V_OnGetTitle;
     //File properties
     property ClientWidth:word read THClientWidth write setClientWidth;
     property ClientHeight:word read THClientHeight write setClientHeight;
     Property FileSize      : longint read FDFileSize write setdummyint;
     Property FileAccessed  : string read FDFileAccessed write setdummystr;
     Property FIleCreated   : string read FDFileCreated write setdummystr;
     Property FileChanged   : string read FDFileChanged write setDummystr;
     Property ImageWidth    : longint read IGWIdth default 0;
     Property ImageHeight   : Longint read IGHeight default 0;
     Property Asbutton      : boolean read PAsbutton write PAsbutton;
     Property MinimizeMemory: Boolean read Tminimize write SetMinimize;
  end;

procedure Register;

implementation
uses THumbview;

//******************* Thumbtitle Procedure and functions ******************

procedure TThumbtitle.Mousedown(Button:TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mousedown(button,shift,x+left,y+top)
  else inherited;
end;

procedure TThumbTitle.mouseup(Button:TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mouseup(button,shift,x+left,y+top)
  else inherited;
end;

procedure TThumbTitle.click;
begin
  if parent is tthumbnail then TTHumbnail(parent).click
  else inherited;
end;

procedure TThumbTitle.Dblclick;
begin
  if parent is tthumbnail then TTHumbnail(parent).Dblclick
  else inherited;
end;

procedure TThumbTitle.mousemove(Shift: TShiftState;X,Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mousemove(shift,x+left,y+top)
  else inherited;
end;

//******************* THumbshape procedure and functions; *****************

procedure TThumbshape.Mousedown(Button:TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mousedown(button,shift,x+left,y+top)
  else inherited mousedown(button,shift,x,y);
end;

procedure TThumbshape.mouseup(Button:TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mouseup(button,shift,x+left,y+top)
  else inherited;
end;

procedure TThumbshape.click;
begin
  if parent is tthumbnail then TTHumbnail(parent).click
  else inherited;
end;

procedure TThumbshape.Dblclick;
begin
  if parent is tthumbnail then TTHumbnail(parent).Dblclick
  else inherited;
end;

procedure TThumbshape.mousemove(Shift: TShiftState;X,Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mousemove(shift,x+left,y+top)
  else inherited;
end;

//***********************THumbimage procedure and functions;****************

Constructor TThumbimage.create(Aowner:Tcomponent);
Begin
  inherited;
  cangle:=AT0;
  Pchanged:=false;
end;

Destructor TThumbimage.destroy;
begin
  Tbrake:=false;
  if assigned(onrelease) then onrelease(self,modified,Tbrake);
  if Tbrake then exit;
  inherited;
end;

Procedure TThumbImage.ScaleDown(MaxW,MaxH:longint);
var
  newsize:tpoint;
  bmp:Graphics.tbitmap;
begin
  newsize:=proportionalsize(point(picture.width,picture.height),point(maxw,maxh));
  if (newsize.x>picture.Width) and (newsize.y>picture.height) then exit;
  bmp:=graphics.tbitmap.create;
  bmp.Width:=newsize.x;
  bmp.height:=newsize.y;
  bmp.handletype:=bmdib;
  bmp.pixelformat:=pf24bit;
  bmp.canvas.stretchdraw(rect(0,0,bmp.width,bmp.height),picture.graphic);
  picture.Assign(bmp);
  picture.Bitmap.Dormant;
  bmp.free;
  PChanged:=true;
end;

function TThumbimage.getmodify:boolean;
begin
  if picture.graphic.empty then result:=false
  else
  if picture.graphic is graphics.tbitmap then result:=true
  else
  if picture.graphic is tjpegimage then result:=true
  else result:=false;
  {if parent is tthumbnail then
    if TTHumbnail(parent).MinimizeMemory then result:=false;{}
end;

Procedure TThumbimage.ChangeRGBCurves(r,g,b:TcurveArray);
var
  color  : prgb;
  membmp : GRaphics.Tbitmap;
  row,col: word;
begin
{
This procedure substitutes the values of r,g,b acordinally to the arrays the
user passes in it. This is the simplest way to change the curve of a color
depending on an algorith created by the user.
The substitute value of a red 0 is the value which lies in the r[0] position.
}
  if canmodify then
  begin
    membmp:=GRaphics.TBitmap.create;
    membmp.width:=picture.width;
    membmp.height:=picture.Height;
    membmp.Assign(picture.graphic);
    membmp.PixelFormat:=pf24bit;
    membmp.HandleType:=bmdib;
    for Row := 0 to membmp.Height - 1 do
    begin
      Color := membmp.ScanLine[Row];
      for Col := 0 to membmp.Width - 1 do
      begin
        Color[Col].rgbtRed  := r[Color[Col].rgbtRed];
        Color[Col].rgbtGreen:= g[Color[Col].rgbtGreen];
        Color[Col].rgbtBlue := b[Color[Col].rgbtBlue];
      end;
    end;
    if picture.graphic is Tjpegimage then
      Tjpegimage(picture.graphic).assign(membmp);
    if picture.graphic is Graphics.Tbitmap then
       picture.bitmap.assign(membmp);
    membmp.free;
  end;
end;

Procedure TThumbimage.ChangeRGB(r,g,b:longint);

{
Just a simple procedure to increase or decrease the values of the each channel
in the image idependendly from each other. E.G.
lets say the r,g,b vars have the values of 5,-3,7 this means that the red channel
should be increased buy 5 points in all the image the green value will be
decreased by 3 points and the blue value will be increased by 7 points.
This will happened to all the image by the same value no color limunocity is been
preserved or values calculations depenting on the current channel values;
}

var
  PixColor : PRGB;
  inbmp    : Graphics.tbitmap;
  Row, Col : integer;
begin
  if not CanModify then exit;
  screen.cursor:=crhourglass;
  inbmp:=Graphics.Tbitmap.create;
  inbmp.width:=picture.width;
  inbmp.height:=picture.height;
  inbmp.assign(picture.graphic);
  Inbmp.HandleType:=bmDib;
  inbmp.PixelFormat:=Pf24bit;
  for Row := 0 to inbmp.Height - 1 do
  begin
    PixColor := inbmp.ScanLine[Row];
    for Col := 0 to inbmp.Width - 1 do
    begin
      PixColor[Col].rgbtRed  := boundbyte(0,255,pixcolor[Col].rgbtRed+r);
      PixColor[Col].rgbtGreen:= boundbyte(0,255,PixColor[Col].rgbtGreen+g);
      PixColor[Col].rgbtBlue := boundbyte(0,255,PixColor[Col].rgbtBlue+b);
    end;
  end;
  if picture.graphic is Tjpegimage then tJpegimage(picture.graphic).assign(inbmp)
  else picture.bitmap.assign(inbmp);
  invalidate;
  inbmp.free;
  Pchanged:=true;
  Screen.cursor:=crArrow;
end;

procedure tthumbimage.rotate(Vangle:Tangle);
begin
{
Procedure to actually decide wich should be the rotation in conjuction with the
images phisical position;
}

  if assigned(picture.graphic) then
  if canmodify then
  if Cangle<> Vangle then
  begin
    if Vangle = At0 then
    begin
      if Cangle = AT90  then
         begin
           rotate270;
           if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
         end;
      if Cangle = AT180 then
        begin
          rotate180;
        end;
      if cangle = AT270 then
        begin
          Rotate90;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
    end;
    if Vangle = AT90 then
    begin
      if Cangle=AT180 then
        begin
          rotate270;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
      if Cangle=AT270 then
        begin
          rotate180;
        end;
      if Cangle=at0 then
        begin
          rotate90;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
    end;
    if Vangle = AT180 then
    begin
      if Cangle=AT90 then
        begin
          rotate90;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
      if Cangle=AT0 then
        begin
          rotate180;
        end;
      if Cangle=AT270 then
        begin
          Rotate270;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
    end;
    if Vangle = AT270 then
    begin
      if Cangle=AT90 then
        begin
          rotate180;
        end;
      if Cangle=AT0 then
        begin
          rotate270;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
      if Cangle=AT180 then
        begin
          Rotate90;
          if parent is TThumbnail then
               sendmessage(TTHumbnail(parent).handle,TH_Imagesizechanged,0,0);
        end;
    end;
    Cangle:=vAngle;
    If cangle<>At0 then Pchanged:=true
    else Pchanged:=false;
  end;
end;

Procedure TThumbimage.rotate270;
var
  membmp:graphics.Tbitmap;
  rotatebmp:graphics.Tbitmap;
  i,j:longint;
begin
{
Procedure to rotate the image at 270 deegres clockwise or 90d ccw
}
  if assigned(picture.graphic) then
  if canmodify then
  begin
  if not assigned(OnRotate) then screen.cursor:=crhourglass;
  membmp:=Graphics.tbitmap.create;
  membmp.Width:=picture.width;
  membmp.Height:=picture.Height;
  membmp.canvas.Draw(0,0,picture.graphic);
  membmp.Palette:=picture.graphic.Palette;
  rotatebmp:=Graphics.Tbitmap.create;
  rotatebmp.assign(membmp);
  rotatebmp.width:=membmp.height;
  rotatebmp.height:=membmp.width;
  with membmp.Canvas.ClipRect do
    for i := Left to Right do
      for j := Top to Bottom do
        begin
          rotatebmp.Canvas.Pixels[j,Right-i-1]:=
               membmp.Canvas.Pixels[i,j];
          if assigned(onrotate) then
           begin
             Tbrake:=false;
             onrotate(self,trunc(((right*bottom)/(i*j))*100),Tbrake);
             if Tbrake then
              begin
                membmp.free;
                rotatebmp.free;
                Tbrake:=false;
                exit;
              end;
           end;
        end;
  picture.bitmap.assign(rotatebmp);
  invalidate;
  membmp.free;
  rotatebmp.free;
  if not assigned(OnRotate) then Screen.cursor:=crArrow;
  end;
end;

procedure TThumbimage.rotate180;
var
  membmp:graphics.Tbitmap;
  rotatebmp:graphics.Tbitmap;
  i,j:longint;
begin
{
Procedure to rotate the image at 180d cw or ccw is the same
}
  if assigned(picture.graphic) then
  if canmodify then
  begin
  if not assigned(OnRotate) then screen.cursor:=crhourglass;
  membmp:=Graphics.tbitmap.create;
  membmp.Width:=picture.width;
  membmp.Height:=picture.Height;
  membmp.canvas.Draw(0,0,picture.graphic);
  membmp.Palette:=picture.graphic.Palette;
  rotatebmp:=Graphics.Tbitmap.create;
  rotatebmp.assign(membmp);
  with membmp.Canvas.ClipRect do
    for i := Left to Right do
      for j := Top to Bottom do
        begin
          rotatebmp.Canvas.Pixels[Right-i-1,Bottom-j-1] :=
            membmp.Canvas.Pixels[i,j];
          if assigned(onrotate) then
          begin
            Tbrake:=false;
            onrotate(self,trunc(((i*j)/(right*bottom))*100),Tbrake);
            if Tbrake then
            begin
              rotatebmp.free;
              membmp.free;
            end;
          end;
        end;
  picture.bitmap.assign(rotatebmp);
  invalidate;
  rotatebmp.free;
  membmp.free;
  if not assigned(OnRotate) then screen.cursor:=crArrow;
  end;
end;

procedure TThumbimage.rotate90;
var
  membmp:graphics.Tbitmap;
  rotatebmp:graphics.Tbitmap;
  i,j:longint;
begin
{
Procedure to rotate an image at 90D clockwise or 270D ccw
}
  if assigned(picture.graphic) then
  if canmodify then
  begin
  if not assigned(OnRotate) then screen.cursor:=crhourglass;
  membmp:=Graphics.tbitmap.create;
  membmp.Width:=picture.width;
  membmp.Height:=picture.Height;
  membmp.canvas.Draw(0,0,picture.graphic);
  membmp.Palette:=picture.graphic.Palette;
  rotatebmp:=Graphics.Tbitmap.create;
  rotatebmp.assign(membmp);
  rotatebmp.width:=membmp.height;
  rotatebmp.height:=membmp.width;
  with membmp.Canvas.ClipRect do
    for i := Left to Right do
      for j := Top to Bottom do
        begin
          rotatebmp.Canvas.Pixels[Bottom-j-1,i]:=
             membmp.Canvas.Pixels[i,j];
          if assigned(onrotate) then
           begin
             Tbrake:=false;
             onrotate(self,trunc(((right*bottom)/(i*j))*100),Tbrake);
             if Tbrake then
             begin
               rotatebmp.free;
               membmp.free;
               Tbrake:=false;
               exit;
             end;
           end;
        end;
  picture.bitmap.assign(rotatebmp);
  invalidate;
  rotatebmp.destroy;
  membmp.destroy;
  if not assigned(OnRotate) then screen.cursor:=crarrow;
  end;
end;

procedure TThumbImage.Mousedown(Button:TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mousedown(button,shift,x+left,y+top)
  else
    inherited mousedown(button,shift,x,y);
end;

procedure TThumbImage.mouseup(Button:TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mouseup(button,shift,x+left,y+top)
  else
    inherited mouseup(button,shift,x,y);
end;

procedure TThumbImage.mousemove(Shift: TShiftState;X,Y: Integer);
begin
  if Parent is TThumbNail then
    TThumbNail(parent).mousemove(shift,x+left,y+top)
  else inherited mousemove(shift,x,y);
end;

procedure TThumbimage.click;
begin
  if parent is Tthumbnail then TThumbnail(parent).click
  else inherited click;
end;

procedure TThumbimage.dblclick;
begin
  if parent is Tthumbnail then TThumbnail(parent).Dblclick
  else inherited dblclick;
end;

//***********************THumbnail procedure and functions;****************

Procedure Tthumbnail.SetStream(Astream:Tstream);
var
  bmp:Graphics.Tbitmap;
  size:tpoint;
begin
  photo.Picture.Graphic.LoadFromStream(Astream);
  if Tminimize then
  begin
    bmp:=GRaphics.TBitmap.Create;
    if parent is TThumbview then
      size:=proportionalsize(point(photo.picture.width,photo.picture.height),
           point(TTHumbview(parent).maxWidth,TThumbview(parent).MAxheight))
    else
      size:=proportionalsize(point(photo.picture.width,photo.picture.height),
                             point(width,height));
    bmp.width:=size.x;
    bmp.Height:=size.y;
    bmp.handletype:=bmDib;
    bmp.pixelformat:=pf24bit;
    bmp.canvas.stretchdraw(rect(0,0,bmp.width,bmp.height),photo.picture.graphic);
    photo.picture.Assign(bmp);
    bmp.free;
  end;
end;


Procedure TThumbnail.setClientWidth(Awidth:word);
begin
  THClientWidth:=(width - (borderwidth*2))-8;
end;

Procedure TThumbnail.SetClientHeight(aheight:word);
Begin
  if assigned(V_titlepanel) then
    THClientHeight:=Height-(V_TitlePanel.Height+8)
  else THClientHeight:=Height - 8;
end;

procedure TTHumbnail.setdummystr(AnStr:string);
begin
end;

Procedure TThumbnail.SetDummyInt(AnInt:longint);
begin
end;

procedure TThumbNail.PhotoOnProgress(Sender: TObject;Stage: TProgressStage;
     PercentDone: Byte; RedrawNow: Boolean;const R: TRect; const Msg: string);
begin
  if Stage = psEnding then
  begin
    V_ImageReady := True;
    RedrawNow := true;
    exit;
  end;
  V_ImageReady := False;
end;

Procedure TThumbNail.mousedown(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if asbutton then
  if button=mbleft then
  begin
    MousePressed := True;
    BevelOuter := bvlowered;
  end;
  if parent is TTHumbview then
    TThumbview(parent).mousedown(button,shift,left+x,top+y);
  inherited;
end;

procedure TThumbNail.mousemove(Shift: TShiftState; X,Y: Integer);
begin
  if asbutton then
  if MousePressed then
    begin
      if (x<0) or (x>width) or (y<0) or (y>height) then
        bevelouter:=bvraised
      else
        bevelouter:=bvlowered;
      end;
  inherited;
end;

procedure TThumbNail.mouseup(Button: TMouseButton;Shift: TShiftState;X, Y: Integer);
begin
  if asbutton then
  if button=mbleft then
  begin
    MousePressed:=false;
    bevelouter:=bvraised;
  end;
  inherited;
end;

procedure TThumbNail.resize;
begin
  if not destroying then
    begin
      CalculateImagesize;
      inherited resize;
    end;
end;

procedure TThumbnail.Getfileinfo;
var
  FileInfo:Twin32finddata;
  h:Thandle;
  dft:dword;
  lft:tfiletime;
begin
  h:=windows.findfirstfile(pchar(Fphoto),fileinfo);
  if (invalid_handle_value <> h) then
   begin
     windows.findclose(h);
     filetimetolocalfiletime(fileinfo.ftLastAccessTime,lft);
     filetimetodosdatetime(lft,longrec(dft).hi,longrec(dft).lo);
     try
       fdFileAccessed:=datetimetostr(filedatetodatetime(dft));
     except
       fdFileAccessed:='Unknown'
     end;
     filetimetolocalfiletime(fileinfo.ftLastwriteTime,lft);
     filetimetodosdatetime(lft,longrec(dft).hi,longrec(dft).lo);
     try
       fdFilechanged:=datetimetostr(filedatetodatetime(dft));
     except
       fdFileChanged:='Unknown';
     end;
     filetimetolocalfiletime(fileinfo.ftCreationTime,lft);
     filetimetodosdatetime(lft,longrec(dft).hi,longrec(dft).lo);
     Try
       fdFileCreated:=datetimetostr(filedatetodatetime(dft));
     except
       fdFilecreated:='Unknown';
     end;
     FDfilesize:=(fileinfo.nfilesizehigh * maxdword)+fileinfo.nfilesizelow;
   end;
end;

procedure TThumbNail.SetFile(Afile:string);
begin
  if afile<>null then
    begin
      try
        photo.picture.LoadFromFile(afile);
      except
        On Ejpeg do;
      end;
      getfileinfo;
      Calculateimagesize;
      photo.visible:=true;
      Fphoto:=Afile;
      if Tminimize then
        if owner is TThumbnail then
          photo.scaledown(TTHumbview(owner).maxWidth,TTHumbview(owner).maxheight)
        else
          Photo.scaledown(width,height);
    end
  else fphoto:=null;
end;

procedure TThumbNail.CalculateImageSize;
var
  Percent       : Byte;
  tempx,tempy   : Single;
begin
  setclientheight(15);
  setclientwidth(15);
  if (photo.picture.width>clientwidth) or (photo.picture.height>clientheight) then
   begin
     tempx:=((clientwidth)/photo.picture.width)*100;
     tempy:=((clientheight)/photo.picture.height)*100;
   end
  else
   begin
     tempx:=100;
     tempy:=100;
   end;
  if tempx<=tempy then
    percent:=trunc(tempx)
  else
    percent:=trunc(tempy);
  photo.width:=trunc((photo.picture.width/100)*percent);
  photo.height:=trunc((photo.picture.height/100)*percent);
  photo.Left:=trunc(width/2-photo.width/2);
  photo.top:=(v_TitlePanel.height div 2)+(Height div 2)-(photo.height div 2);
end;

Constructor TThumbNail.Create(Aowner:Tcomponent);
begin
  inherited create(Aowner);
  V_Shape := TthumbShape.Create(Self);
  V_Shape.Align := alClient;
  V_Shape.Brush.Color := clInactiveCaptionText;
  V_Shape.Brush.Style := bsBdiagonal;
  Photo := TThumbImage.Create(self);
  Photo.AutoSize:= False;
  Photo.Align := alNone;
  Photo.Stretch := True;
  Photo.OnProgress := PhotoOnProgress;
  V_TitlePanel := TThumbtitle.Create(Self);
  V_TitlePanel.Align := alTop;
  V_TitlePanel.Height := 15;
  V_TitlePanel.Alignment := taCenter;
  V_TitlePanelColor := clBtnFace;
  V_TitlePanel.Color := V_TitlePanelColor;
  V_TitlePanelFont := TFont.Create;
  V_TitlePanelFont.OnChange := RefreshFont;
  v_titlepanel.bevelouter:=bvlowered;
  V_Title := '';
  V_Updated := False;
  InsertControl(V_Shape);
  InsertControl(Photo);
  InsertControl(V_TitlePanel);
  Align:=alNone;
  if aowner is tthumbview then
    begin
      width:=tthumbview(owner).maxwidth;
      height:=TThumbview(owner).maxheight;
    end
  else
    begin
      width:=120;
      height:=120;
    end;
  Tminimize:=true;
  Asbutton:=false;
  Left := 10;
  Top := 10;
  Visible := True;
  Bevelouter := bvraised;
end;

procedure TThumbnail.THSizechanged(var Message:tmessage);
begin
  calculateimagesize;
end;

Destructor TThumbNail.destroy;
begin
  destroying:=true;
  Photo.OnProgress := nil;
  V_TitlePanelFont.Onchange := nil;
  V_TitlePanelFont.Free;
  V_Shape.Free;
  inherited destroy;
end;

procedure TThumbNail.PSetV_Title(const Value: string);
begin
  if Value <> V_Title then
  begin
    V_Title := Value;
    V_TitlePanel.Caption := Value;
  end;
end;

procedure TThumbNail.WMPaint(var Message: TWMPaint);
var
  ThumbNailTitle  : string;
begin
  inherited;
  if not V_Updated then
    begin
      ThumbNailTitle := '';
      if Assigned(V_OnGetTitle) then
        begin
          V_OnGetTitle(Self,filename,ThumbNailTitle);
          PSetV_Title(ThumbNailTitle);
        end
      else
        begin
          PSetV_Title(ExtractFileName(filename));
        end;
          V_Updated := True;
    end;
end;

procedure TThumbNail.PSetV_TitlePanelColor(const Value: TColor);
begin
  if Value <> V_TitlePanelColor then
  begin
    V_TitlePanelColor := Value;
    V_TitlePanel.Color := Value;
  end;
end;

procedure TThumbNail.PSetV_TitlePanelFont(const Value: TFont);
begin
  V_TitlePanelFont.Assign(Value);
end;

procedure TThumbNail.Refreshfont(Sender: TObject);
begin
  V_TitlePanel.Font.Assign(V_TitlePanelFont);
end;

procedure TThumbNail.SetTitlePanel(P_Title: string;P_Font: TFont; P_Color: TColor);
begin
	PSetV_TitlePanelFont(P_Font);
	PSetV_TitlePanelColor(P_Color);
	PSetV_Title(P_Title);
	V_Updated := True;
end;

Procedure TTHumbnail.setminimize(min:boolean);
begin
  if assigned(photo.picture.graphic) then
  if tminimize<>min then
  begin
  if (min) then
    begin
      if owner is TTHumbview then
        photo.ScaleDown(Tthumbview(owner).MaxWidth,TThumbview(owner).MaxHeight)
      else
        photo.ScaleDown(Width,Height);
    end
  else
    if tminimize then photo.picture.loadfromfile(filename);
  Tminimize:=min;
  end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TThumbimage]);
  RegisterComponents('Samples', [TThumbNail]);
end;

end.
